package de.tud.kom.p2psim.impl.network.fairshare;

import java.util.Collections;
import java.util.LinkedHashSet;
import java.util.LinkedList;

/**
 * An implementation of the fair share bandwidth allocation algorithm. TODO
 * extend and move to a sensible place.
 * 
 * @author Tobias Lauinger
 */
public class FairShareAlgorithm {

	/**
	 * Runs the fair share algorithm.
	 * 
	 * NOTE: CHANGED by Peter Heise: 
	 * 
	 * 	Did not recalculate all links on remove. Now has to called like:
	 * 			LinkedHashSet<Connection> links = new LinkedHashSet<Connection>();
	 * 			receiver.traverseConnections(links, true);
	 * 			sender.traverseConnections(links, false);
	 * 			fairShare.run(links);
	 * 
	 * 
	 * @param links
	 *            Collection of all affected links
	 */
	public void run(LinkedHashSet<Connection> links) {
		
		LinkedList<Connection> sortedLinks = new LinkedList<Connection>(links);
		Collections.sort(sortedLinks);
		
		while( !sortedLinks.isEmpty() ) {
			
			Connection min = sortedLinks.remove(0);
			min.assignBandwidth(min.getMinBid());

			/*
			 * NOTE: CHANGED by Peter Heise:
			 * 	Needs to be recalculated in every iteration so that all flows are fully saturated.
			 * 
			 * Reference: "Accurate and Efficient Simulation of Bandwidth Dynamics for Peer-To-Peer Overlay Networks"
			 * 				by Alexandros Gkogkas, see proposed Algorithm 1.
			 * 
			 */
			Collections.sort(sortedLinks);
			
		}

	}

}
