package de.tud.kom.p2psim.impl.network.fairshare;

import org.apache.log4j.Logger;

import de.tud.kom.p2psim.api.common.Position;
import de.tud.kom.p2psim.api.network.NetLatencyModel;
import de.tud.kom.p2psim.api.network.NetLayer;
import de.tud.kom.p2psim.impl.util.logging.SimLogger;
import de.tudarmstadt.maki.simonstrator.api.Time;

public class OptimizedLatencyModel implements NetLatencyModel {

	private static Logger log = SimLogger
			.getLogger(OptimizedLatencyModel.class);

	@Override
	public long getLatency(NetLayer sender, NetLayer receiver) {
		Position senderPos = sender.getNetPosition();
		Position receiverPos = receiver.getNetPosition();
		double minRtt = senderPos.getDistance(receiverPos);
		double receiveTime = minRtt / 2.0;
		long latency = Math.round(receiveTime * Time.MILLISECOND);
		log.info("Propagation Delay for " + sender.getNetID() + " to "
				+ receiver.getNetID() + ": " + receiveTime + " ms");
		return latency;
	}

}