/*
 * Copyright (c) 2005-2011 KOM - Multimedia Communications Lab
 *
 * This file is part of PeerfactSim.KOM.
 * 
 * PeerfactSim.KOM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 * 
 * PeerfactSim.KOM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with PeerfactSim.KOM.  If not, see <http://www.gnu.org/licenses/>.
 *
 */



package de.tud.kom.p2psim.impl.util.logging;

import org.apache.log4j.Logger;

/**
 * This is a wrapper class for log4j. Log4j is a logging package for printing
 * log output to different local and remote destinations. <strong>See
 * <code>log4j.properties</code> for configuration</strong>. Be sure to include
 * the path to log4j.jar in your CLASSPATH. See <a
 * href="http://logging.apache.org/log4j/1.2/index.html">log4j documentation</a>
 * for more details.
 * 
 * @author Andre Mink
 * 
 */
public class SimLogger {

	private static SimLogger simLogger;

	private SimLogger() {
		//
	}

	/**
	 * The common and encouraged way to obtain loggers in the simulator. The
	 * usage of this method will ensure that all loggers are configured from the
	 * same configuration file, <code>log4j.properties</code> in the root dir of
	 * the distribution dir.
	 * 
	 * @param c
	 *            - class for which the logger is required
	 * @return logger instance
	 */
	public static Logger getLogger(Class c) {
		Logger l = Logger.getLogger(c);
		l.trace("Initialized logger");
		return l;
	}

}
